<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <!-- Mask -->
            <span class="mask bg-gradient-primary opacity-8"></span>
        </base-header>

        <div class="container-fluid mt--7">
            <div class="form-group">
                <div class="col-xl-12 order-xl-1">
                    <card shadow type="secondary">
                        <div slot="header" class="bg-white border-0">
                            <div class="row align-items-center">
                                <div class="col-8">
                                    <h3 class="mb-0">{{topic_cmd}}</h3>
                                </div>
                            </div>
                        </div>
                        <template>
                           <div class="col-lg-12">
                                <textarea
                                    id="textarea"
                                    v-model="command"
                                    placeholder="Command"
                                    rows="2"
                                    class="form-control">
                                </textarea>
                                <br>
                                <div class="alert alert-warning" v-if="messagePub">{{messagePub}}</div>
                                <hr class="my-4" />
                                    <div class="form-group">
                                        <button class="btn btn-lg btn-success" type="button" @click="publishTopic()">Publish</button>
                                    </div>
                                </div>    
                        </template>
                    </card>
                </div>
            </div>
                <div class="form-group">
                <div class="col-xl-12 order-xl-1">
                    <card shadow type="secondary">
                        <div slot="header" class="bg-white border-0">
                            <div class="row align-items-center">
                                <div class="col-8">
                                    <h3 class="mb-0">{{topic_status}}</h3>
                                </div>
                            </div>
                        </div>
                        <template>
                           <div class="col-lg-12">
                               <div class="alert alert-warning" v-if="messageSub">{{messageSub}}</div>
                                    <div class="form-group">
                                        <button class="btn btn-lg btn-success" type="button" @click="subscribeTopic()">Subscribe</button>
                                    </div>
                                </div>    
                        </template>
                    </card>
                </div>
                </div>
                <div class="form-group">
                <div class="col-xl-12 order-xl-1">
                    <card shadow type="secondary">
                        <div slot="header" class="bg-white border-0">
                            <div class="row align-items-center">
                                <div class="col-8">
                                    <h3 class="mb-0">{{topic_response}}</h3>
                                </div>
                            </div>
                        </div>
                        <template>
                           <div class="col-lg-12">
                                    <div class="form-group">
                                        <button class="btn btn-lg btn-success" type="button" @click="sendcommandResponse()">Publish</button>
                                    </div>
                                </div>    
                        </template>
                    </card>
                </div>
                </div>
            </div>
        </div>
        
</template>
<script>
  export default {
    name: 'manage-users',
    data() {
      return {
        topic_cmd : '',
        topic_status : '',
        topic_response : '',
        command : '',
        messagePub : '',
        messageSub : ''
      }
    },
    created() {
        this.getTopic()
    },
    methods: {
        getTopic(){
            this.$http.get('/manage/alltopic/topic/'+localStorage.topic_id)
            .then(response => {
                this.topic_cmd = response.data.topic+'CMD'
                this.topic_status = response.data.topic+'STATUS'
                this.topic_response = response.data.topic+'RESPONSE'
          })
        },
        publishTopic(){
             this.$http.post('/api/publish',{
                 topic : this.topic_cmd,
                 command : this.command
             })
            .then(response => {
                this.messagePub = response.data
                
          })
        },
        subscribeTopic(){
            this.$http.post('/api/subscribe',{
                topic: this.topic_status 
                })
            .then(response => {
                this.messageSub = response.data
                
          })
        }
    },
  };
</script>